Program echom;

{ compile with 
   
    gpc -o echom echom.pas -lsocket -lnsl closewrapper.o



 
Copyright (C) 1997-2003 Clyde Meli <cmeli@cis.um.edu.mt> and
V. Nezval <vnez@cis.um.edu.mt> of the Department of Computer
Information Systems, University of Malta, Malta

SOCKStrc and associated files are free software; you can redistribute and/or
modify them under the terms of the GNU Library Public License, as published
by the Free Software Foundation. This redistribution has been registered
with Kopjamalt, the Maltese RRO.

You should have received a copy of the GNU General Public License (file COPYING)
and the GNU Library Public License (file COPYING.LIB) along with this package;
if not, write to the Free Software Foundation, Inc., 675 Mass Ave, Cambridge,
MA 02139, USA.

SOCKStrc and its associated files are distributed in the hope that they
will be useful, and that others may learn from them, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
FOR A PARTICULAR PURPOSE. See the GNU General Public License and the
GNU Library Public License for more details.



  }

Uses c_types,sockstrc;



CONST

  MAXDATASIZE = 100;

VAR
  s,rc:integer;
  port:integer;
  sin,that:sockaddr_in;
  inad:in_addr;
  hp:hostentptr;
  pName:CString;
  cp:Cstringptr;
  child:pid_t;
  f:TEXT;
  line:string[255];
  k,i:integer;
  bytes_sent,bytes_read:integer;
  buf:array[1..MAXDATASIZE] of char; {CString;}

Begin
  s:=socket(AF_INET,SOCK_STREAM,0);
  Writeln('socket: ',s);
  if s<=0 then 
  Begin
    Writeln('socket creation failed! exiting..');
    halt;
  End;
  
 
{ ====================== illustrate get host by name =========================== }

  getmem (pName,256);
  pName:=StrPCopy(pName,'condor.cis.um.edu.mt'); {someserver.at.your.domain');  convert Pascal string to a C string }
  hp:=PAS_gethostbyname(pName);
  if hp=NIL then 
  Begin
    Writeln('Unknown host --- !');
    {Halt; }
  End
  Else
  Begin
    Writeln('host is ',StrPas(hp^.h_name));
    Writeln('ip address is ',StrPas(inet_ntoa( in_addrptr(hp^.h_addr_list^) ^)));
  End;

{ ====================== illustrate PAS_gethostbyname ========================== }
  hp:=PAS_gethostbyname('condor.cis.um.edu.mt'); {someserver.at.your.domain');}
  if hp=NIL then
  Begin
    Writeln('Unknown host --- !');
    Halt;
  End;
  Writeln('host is ',StrPas(hp^.h_name));
  Writeln('ip address is ',StrPas(inet_ntoa( in_addrptr(hp^.h_addr_list^) ^)));




  FillChar(sin,sizeof(sin),chr(0)); {in C: bzero((Cstring)@sin,sizeof(sin));}

{ ======================= but actually we're using an ip address ======== }
{ ======================= in a real world example you would use the hostname etc === }
  WITH sin DO
  Begin
    sin_family:=AF_INET; {hp^.h_addrtype should always be AF_INET}
    sin_port:=htons(7); { the port for echo is 7. See /etc/services }

    { the following line assumes we use used gethostbyname }
    sin_addr:=in_addrptr(hp^.h_addr_list^) ^;

    { alternatively if you have the ip, you should be able to do something like
      this:

      pName:=StrPCopy(pName,'10.3.2.1');  == ip address of a server - use your ip!
      sin_addr:=inet_makeaddr(inet_network(pName),inet_addr(pName));
    }
  End;
  
 Writeln('attempting to connect to ',StrPas(inet_ntoa(sin.sin_addr)));

  rc :=connect(s,sockaddrptr(@sin),sizeof(sin));
  if rc<>0 then Writeln('failed!') else Writeln('connected');
  
  child := fork;
  if child<>0 then
  Begin
    { we're the parent. read lines of input from stdin and
      send them to the server until eof is seen }
    k:=getchar;
    while k<>-1 do
    Begin
      pName:=StrPCopy(pName,char(k));
      repeat
        bytes_sent := send(s,pName,1,0);
      until bytes_sent = 1;

 
      { write(s,k); does not work! }
      k:=getchar;
    End;
    sleep(3);
  End
  else
  Begin
    { we're the child. read lines of input from the server over
      the socket s and output them.  stop if eof is seen }
    repeat
      bytes_read:=recv(s,Cstring(@buf),MAXDATASIZE,0);
      if bytes_read = -1 then 
      Begin
        Writeln('error in recv');
        Halt;
      End;
      Write('received : ');
      for i:=0 to bytes_read do
      if buf[i]>='A' then Write(buf[i]) else if buf[i]=#10 then Writeln;
    until bytes_read=0;

  End;

  closesocket(s);
     
  freemem (pName,256);

End.



